package ourfirstswingapp;

import java.awt.*;
import java.util.Random;
import javax.swing.*;

/**
 * Órai unchecked warningokat kijavítottam <String> és <> hozzáadásával
 * (DefaultListModel → DefaultListModel<String>, stb)
 *
 * Így nem kell a &#64;SuppressWarnings({"unchecked"}) és nincs raw type found /
 * generic class / missing type argument warning sem.
 *
 * @author Daniel "3ICE" Berezvai
 */
class OurSecondSwingFrame extends JFrame {

  public OurSecondSwingFrame() {
    this.setTitle("Our second swing frame");
    setSize(new Dimension(600, 150));
    setLocation(new Point(200, 200));
    setDefaultCloseOperation(EXIT_ON_CLOSE);
    setLayout(new BorderLayout());
    JPanel panel = new JPanel();
    panel.setLayout(new GridLayout(3, 5));
    getContentPane().add(panel, BorderLayout.CENTER);

    Random rnd = new Random();
    for (int i = 0; i < 3; i++) {
      for (int j = 0; j < 5; j++) {
        int n = rnd.nextInt(6);
        Component comp;
        switch (n) {
          case 0:
            comp = new JButton("Button " + i + ":" + j);
            break;
          case 1:
            comp = new JLabel("Label " + i + ":" + j);
            break;
          case 2:
            comp = new JTextField("TextField " + i + ":" + j);
            break;
          case 3:
            comp = new JSpinner(new SpinnerNumberModel(j, 0, 100, i));
            break;
          case 4:
            comp = new JComboBox<>(new String[]{"ComboBox " + i + ":" + j,
                      "elem 2", "elem 3"});
            break;
          case 5:
            comp = new JCheckBox("CheckBox " + i + ":" + j);
            break;
          default:
            comp = new JButton("ERROR!");
            break;
        }
        panel.add(comp);
      }
    }
    getContentPane().add(new JLabel("Label outside the panel"), BorderLayout.NORTH);
    DefaultListModel<String> defaultListModel = new DefaultListModel<>();
    JList<String> list = new JList<>(defaultListModel);
    getContentPane().add(new JScrollPane(list), BorderLayout.WEST);
    for (Component component : panel.getComponents()) {
      defaultListModel.addElement(component.getClass().getName());
    }
  }
}
